// Copyright 2015 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --strong-mode --allow-natives-syntax

(function() {
"use strict";

let foo = null;

function nullLiteral() {
  class Class1 extends null {
    constructor() {
      super();
    }
  }
}

function nullVariable() {
  class Class2 extends foo {
    constructor() {
      super();
    }
  }
}

function nullLiteralClassExpr() {
  (class extends null {});
}

function nullVariableClassExpr() {
  (class extends foo {});
}

assertDoesNotThrow(nullLiteral);
V8OptimizeFunctionOnNextCall(nullLiteral);
assertDoesNotThrow(nullLiteral);

assertDoesNotThrow(nullVariable);
V8OptimizeFunctionOnNextCall(nullVariable);
assertDoesNotThrow(nullVariable);

assertDoesNotThrow(nullLiteralClassExpr);
V8OptimizeFunctionOnNextCall(nullLiteralClassExpr);
assertDoesNotThrow(nullLiteralClassExpr);

assertDoesNotThrow(nullVariableClassExpr);
V8OptimizeFunctionOnNextCall(nullVariableClassExpr);
assertDoesNotThrow(nullVariableClassExpr);
})();

(function() {
"use strong";

let foo = null;

function nullLiteral() {
  class Class1 extends null {
    constructor() {
      super();
    }
  }
}

function nullVariable() {
  class Class2 extends foo {
    constructor() {
      super();
    }
  }
}

function nullLiteralClassExpr() {
  (class extends null {});
}

function nullVariableClassExpr() {
  (class extends foo {});
}

assertThrows(nullLiteral, TypeError);
V8OptimizeFunctionOnNextCall(nullLiteral);
assertThrows(nullLiteral, TypeError);

assertThrows(nullVariable, TypeError);
V8OptimizeFunctionOnNextCall(nullVariable);
assertThrows(nullVariable, TypeError);

assertThrows(nullLiteralClassExpr, TypeError);
V8OptimizeFunctionOnNextCall(nullLiteralClassExpr);
assertThrows(nullLiteralClassExpr, TypeError);

assertThrows(nullVariableClassExpr, TypeError);
V8OptimizeFunctionOnNextCall(nullVariableClassExpr);
assertThrows(nullVariableClassExpr, TypeError);
})();
